#include <stdio.h>

class graph
{
  int n;
  int ** g;

public:

graph(char * c)
{
  int i, j;

  n = *c-63;
  c++;

  g = new int * [n];
  for (i = 0 ; i < n ; i++)
    g[i] = new int [n];


  int bit = 5;
  int number = *c-63;
  c++;

  for (i = 1 ; i < n ; i++)
  {
    for (j = 0 ; j < i ; j++)
      {
	if (bit == -1)
	  {
            bit = 5;
            number = *c-63;
            c++;
	  }

        g[j][i] = g[i][j] = (number >> bit) & 1;
	bit--;
      }
  }
}

~graph()
{
  for (int i = 0 ; i < n ; i++)
    delete [] g[i];

  delete g;
}

void print_graph()
{
  printf("%c", n+63);

  int bit = 0;
  int number = 0;

  int i, j;
  for (i = 1 ; i < n ; i++)
  {
    for (j = 0 ; j < i ; j++)
      {
	bit++;
	number <<= 1;
	if (g[i][j] == 1)
	  number++;

	if (bit == 6)
	  {
	    printf("%c", number+63);
	    bit = number = 0;
	  }
      }
  }

  if (bit != 0)
    {
      number <<= (6-bit);
      printf("%c", number+63);
    }
  printf("\n");
}

int check_pair(int i, int j, int k, int edgei, int edgej, int edgek)
{
  int l;
  for (l = 0 ; l < i ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej) && (g[k][l] == edgek))
      return 0;

  for (l = i+1 ; l < j ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej) && (g[k][l] == edgek))
      return 0;

  for (l = j+1 ; l < k ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej) && (g[k][l] == edgek))
      return 0;

  for (l = k+1 ; l < n ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej) && (g[k][l] == edgek))
      return 0;

  return 1;
}

void check()
{
  int i,j,k;

  for (i=0 ; i < n ; i++)
    for (j=i+1 ; j < n ; j++)
      for (k=j+1 ; k < n ; k++)
       {
         if (check_pair(i,j,k,0,0,0)) return;
         if (check_pair(i,j,k,0,0,1)) return;
         if (check_pair(i,j,k,0,1,0)) return;
         if (check_pair(i,j,k,1,0,0)) return;
         if (check_pair(i,j,k,0,1,1)) return;
         if (check_pair(i,j,k,1,0,1)) return;
         if (check_pair(i,j,k,1,1,0)) return;
         if (check_pair(i,j,k,1,1,1)) return;
      }

  print_graph();
}
};

int main(int argc, char * argv[])
{
  FILE * in = fopen(argv[1], "rt");

  char graph_text [100];

  while (!feof(in))
  {
    fscanf(in, "%s\n", graph_text);
    graph g(graph_text);
    g.check();
  }

  return 0;
}
