// Checking that the condition is necessary but not sufficient
#include <stdio.h>
#include <conio.h>

class graph
{
  int n;
  int ** g;
  int * tmp;

public:

graph(char * c)
{
  int i, j;

  n = *c-63;
  c++;

  g = new int * [n];
  for (i = 0 ; i < n ; i++)
    g[i] = new int [n];

  int bit = 5;
  int number = *c-63;
  c++;

  for (i = 1 ; i < n ; i++)
  {
    for (j = 0 ; j < i ; j++)
      {
	if (bit == -1)
	  {
            bit = 5;
            number = *c-63;
            c++;
	  }

        g[j][i] = g[i][j] = (number >> bit) & 1;
	bit--;
      }
  }
  tmp = new int [n];
}

~graph()
{
  for (int i = 0 ; i < n ; i++)
    delete [] g[i];

  delete [] g;
  delete [] tmp;
}

void print_graph()
{
  printf("%c", n+63);

  int bit = 0;
  int number = 0;

  int i, j;
  for (i = 1 ; i < n ; i++)
  {
    for (j = 0 ; j < i ; j++)
      {
	bit++;
	number <<= 1;
	if (g[i][j] == 1)
	  number++;

	if (bit == 6)
	  {
	    printf("%c", number+63);
	    bit = number = 0;
	  }
      }
  }

  if (bit != 0)
    {
      number <<= (6-bit);
      printf("%c", number+63);
    }
//  printf("\n");
}

int check_pair(int i, int j, int edgei, int edgej)
{
  int l;
  for (l = 0 ; l < i ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej))
      return 0;

  for (l = i+1 ; l < j ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej))
      return 0;

  for (l = j+1 ; l < n ; l++)
    if ((g[i][l] == edgei) && (g[j][l] == edgej))
      return 0;

  return 1;
}

int check()
{
  int i,j,k;

  for (i=0 ; i < n ; i++)
    for (j=i+1 ; j < n ; j++)
       {
         if (check_pair(i,j,0,0)) return 0;
                                  // { printf("(%d,%d)", i,j); return 0; }
         if (check_pair(i,j,0,1)) return 0;
                                  // { printf("(%d,%d)", i,j); return 0; }
         if (check_pair(i,j,1,0)) return 0;
                                  // { printf("(%d,%d)", i,j); return 0; }
         if (check_pair(i,j,1,1)) return 0;
                                  // { printf("(%d,%d)", i,j); return 0; }
      }
  return 1;
}

int check_nec()
{
  int i,j,k,nr, neigh, nonneigh;
  for (i = 0 ; i < n ; i++)
  {
    // check neighbourhood
    nr = 0;
    for (j = 0 ; j < n ; j++)
      if ((g[i][j]) && (i != j))
        tmp[nr++] = j;

    for (j = 0 ; j < nr ; j++)
    {
      neigh = nonneigh = 1;
      for (k = 0 ; (k < nr) && (neigh || nonneigh) ; k++)
        if (j != k)
          if (g[tmp[j]][tmp[k]]) neigh = 0;
          else nonneigh = 0;

      if (neigh || nonneigh)
        return 0;
    }

    // check non-neighbourhood
    nr = 0;
    for (j = 0 ; j < n ; j++)
      if ((!g[i][j]) && (i != j))
        tmp[nr++] = j;

    for (j = 0 ; j < nr ; j++)
    {
      neigh = nonneigh = 1;
      for (k = 0 ; (k < nr) && (neigh || nonneigh) ; k++)
        if (j != k)
          if (g[tmp[j]][tmp[k]]) neigh = 0;
          else nonneigh = 0;

      if (neigh || nonneigh)
        return 0;
    }

  }
  return 1;
}

};



int main(int argc, char * argv[])
{
  FILE * in = fopen(argv[1], "rt");

  char graph_text [100];
  int suf, nec;

  while (!feof(in))
  {
    fscanf(in, "%s\n", graph_text);
    graph g(graph_text);

    suf = g.check();
    nec = g.check_nec();

    if (suf || nec) g.print_graph();
    if (nec) printf(" NEC");
    if (suf) printf(" SUF");
    if (suf || nec) printf("\n");
  }

  printf("DONE!\n");
  getch();

  return 0;
}


